import VueRouter, { NavigationGuard, Route, RouterOptions } from 'vue-router';
export { RouteMeta, RouterOptions, RouteRecord, RouteConfig as RouteRecordRaw, RedirectOption as RouteRecordRedirectOption, RawLocation as RouteLocationRaw, } from 'vue-router';
export declare type RouteRecordName = string | symbol;
export declare type RouterScrollBehavior = RouterOptions['scrollBehavior'];
export declare type RouteLocationNormalized = Route;
export declare type RouteLocationNormalizedLoaded = Route;
export interface Router extends VueRouter {
    isReady: () => Promise<void>;
    /** @deprecated */
    app: VueRouter['app'];
    /** @deprecated */
    getMatchedComponents: VueRouter['getMatchedComponents'];
    /** @deprecated use `isReady` instead */
    onReady: VueRouter['onReady'];
}
export declare function createRouter(options: RouterOptions): Router;
export declare function useRouter(): Router;
export declare function useRoute(): Route | undefined;
export declare function onBeforeRouteLeave(leaveGuard: NavigationGuard): void;
export declare function onBeforeRouteUpdate(updateGuard: NavigationGuard): void;
